// FileLinkDemoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "FileLinkDemo.h"
#include "FileLinkDemoDlg.h"
#include "shlobj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileLinkDemoDlg Dialogfeld

CFileLinkDemoDlg::CFileLinkDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileLinkDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileLinkDemoDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFileLinkDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileLinkDemoDlg)
		// HINWEIS: Der Klassenassistent fgt an dieser Stelle DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileLinkDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CFileLinkDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileLinkDemoDlg Nachrichten-Handler

BOOL CFileLinkDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CFileLinkDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CFileLinkDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CFileLinkDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Creating a Link with IShellLink
// strPathObj  = Object with Path (source)
// strPathLink = Path where the Link will appear (must end with '.lnk' !!) (destination)
// CoInitialize(NULL) must be done before !!

BOOL CFileLinkDemoDlg::FileLink(const CString strPathObj,
								const CString strPathLink)
{

BOOL bRet = FALSE;
IShellLink* psl;

	if (SUCCEEDED( CoCreateInstance(CLSID_ShellLink,
							NULL,
							CLSCTX_INPROC_SERVER,
							IID_IShellLink,
							(LPVOID*) &psl))
					)
	{
		IPersistFile* ppf;

		psl->SetPath(strPathObj);

		if (SUCCEEDED(psl->QueryInterface( IID_IPersistFile, (LPVOID *) &ppf)))
		{

			WORD wsz[MAX_PATH];
			MultiByteToWideChar(CP_ACP, 
								MB_PRECOMPOSED, 
								strPathLink, 
								-1, 
								wsz,
								MAX_PATH);

			if ( SUCCEEDED ( ppf->Save(wsz, TRUE) ) )
				bRet = TRUE;

			ppf->Release();
		}
		psl->Release();
	}
	return bRet;
}

void CFileLinkDemoDlg::OnOK() 
{
 {// BLOCK - inserted by CFileDialog macro
	 CFileDialog dlg(TRUE, "", "", 
		 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
		 "All Files (*.*)|*.*|All Files (*.*)|*.*||", this);
	 
	 dlg.m_ofn.lpstrTitle = "Select File for a link...";
	 
	 if (dlg.DoModal() == IDOK)
	 {
		char crEnVar[MAX_PATH];
		::GetEnvironmentVariable("USERPROFILE", crEnVar, MAX_PATH);
		if (strlen(crEnVar) > 0)
		{
			CString mFile = dlg.GetPathName();
			CString destPath = CString(crEnVar);
			destPath += "\\Desktop\\";
			destPath += dlg.GetFileName();
			destPath += ".lnk";

			FileLink(mFile, destPath);
		}
		else
		{
			::AfxMessageBox("can'n get Evironment-Variable",MB_OK);
		}

		 // Use dlg.GetPathName() to extract filename (including path);
	 }
 } // End block



	CDialog::OnOK();
}


